StubbleSowingMachineEvent = {};
StubbleSowingMachineEvent_mt = Class(StubbleSowingMachineEvent, Event);

InitEventClass(StubbleSowingMachineEvent, "StubbleSowingMachineEvent");

function StubbleSowingMachineEvent:emptyNew()
  local self = Event:new(StubbleSowingMachineEvent_mt);
  self.className="StubbleSowingMachineEvent";
  return self;
end;

function StubbleSowingMachineEvent:new(object, isActive)
  local self = StubbleSowingMachineEvent:emptyNew()
  self.object = object;
  self.isActive = isActive;
  return self;
end;

function StubbleSowingMachineEvent:readStream(streamId, connection)
  local id = streamReadInt32(streamId);
  self.isActive = streamReadBool(streamId);
  self.object = networkGetObject(id);
  self:run(connection);
end;

function StubbleSowingMachineEvent:writeStream(streamId, connection)
  streamWriteInt32(streamId, networkGetObjectId(self.object));
  streamWriteBool(streamId, self.isActive);
end;

function StubbleSowingMachineEvent:run(connection)
  self.object:setStubbleSowingMachineActive(self.isActive, true);
  if not connection:getIsServer() then
    g_server:broadcastEvent(StubbleSowingMachineEvent:new(self.object, self.isActive), nil, connection, self.object);
  end;	
end;

function StubbleSowingMachineEvent.sendEvent(StubbleSowingMachine, isActive)
  if g_server ~= nil then
    g_server:broadcastEvent(StubbleSowingMachineEvent:new(StubbleSowingMachine, isActive), nil, nil, StubbleSowingMachine);
  else
    g_client:getServerConnection():sendEvent(StubbleSowingMachineEvent:new(StubbleSowingMachine, isActive));
  end;
end;

