-- StubbleSowingMachine
-- Spec for StubbleSowingMachine to be used with chopped straw
-- by yumi

SpecializationUtil.registerSpecialization('StubbleSowingMachine', 'StubbleSowingMachine', g_currentModDirectory .. 'StubbleSowingMachine.lua');
local StubbleSowingMachineSpec = SpecializationUtil.getSpecialization('StubbleSowingMachine');

StubbleSowingMachine_Register = {};
local modItem = ModsUtil.findModItemByModName(g_currentModName);
StubbleSowingMachine_Register.version = (modItem and modItem.version) and modItem.version or "1.1";

--
StubbleSowingMachine_Register.initialized = false

function StubbleSowingMachine_Register:loadMap(name)
	if self.specAdded then return; end;

	print('*** StubbleSowingMachine v'..StubbleSowingMachine_Register.version..' specialization loading ***');

	local addedTo = {};

	for k, v in pairs(VehicleTypeUtil.vehicleTypes) do
		if v ~= nil then
			-- has SowingMachine spec -> continue
			local allowInsertion = SpecializationUtil.hasSpecialization(SowingMachine, v.specializations);

			--local customEnvironment;
			if allowInsertion then
				 print(('\tvehicleType %q has sowingMachine spec'):format(v.name));
				if v.name:find('.') then
					customEnvironment = Utils.splitString('.', v.name)[1];
          --print(('\t\tcustomEnvironment=%q'):format(customEnvironment));
				end;

				if customEnvironment then
					-- has StubbleSowingMachine spec -> abort
					if rawget(SpecializationUtil.specializations, customEnvironment .. '.StubbleSowingMachine') ~= nil or rawget(SpecializationUtil.specializations, customEnvironment .. '.StubbleSowingMachine') ~= nil then
						 print(('\t\talready has spec "StubbleSowingMachine" -> allowInsertion = false'));
						allowInsertion = false;
					end;
				end;
			end;

			if allowInsertion then
				print(('\tStubbleSowingMachine spec added to %q'):format(v.name));
				table.insert(v.specializations, StubbleSowingMachineSpec);
				addedTo[#addedTo + 1] = v.name;
			end;
		end;
	end;


	self.specAdded = true;
end;

function StubbleSowingMachine_Register:update(dt)
  if not StubbleSowingMachine_Register.initialized then
    StubbleSowingMachine_Register.initialized = true -- Only initialize ONCE.
  end;
end;
  
-- Texts
StubbleSowingMachine.l10nTexts = {};
StubbleSowingMachine.l10nTexts["StubbleSowingMachine_Activate"] = g_i18n:getText("StubbleSowingMachine_Activate");
StubbleSowingMachine.l10nTexts["StubbleSowingMachine_Deactivate"] = g_i18n:getText("StubbleSowingMachine_Deactivate");

function StubbleSowingMachine_Register:deleteMap() end;
function StubbleSowingMachine_Register:keyEvent(unicode, sym, modifier, isDown) end;
function StubbleSowingMachine_Register:mouseEvent(posX, posY, isDown, isUp, button) end;
function StubbleSowingMachine_Register:draw() end;

addModEventListener(StubbleSowingMachine_Register);
